From cee98e71bb3d69e41cd4d2c6e33c68639dd1eaf0 Mon Sep 17 00:00:00 2001
From: Rosen Penev <rosenp@gmail.com>
Date: Thu, 5 Dec 2019 12:13:44 -0800
Subject: [PATCH] Fix compilation without deprecated APIs

---
 dnssec_verify.c | 2 ++
 drill/drill.c   | 2 ++
 keys.c          | 1 +
 3 files changed, 5 insertions(+)

diff --git a/dnssec_verify.c b/dnssec_verify.c
index d22962eb..99a7515d 100644
--- a/dnssec_verify.c
+++ b/dnssec_verify.c
@@ -597,7 +597,9 @@ ldns_dnssec_trust_tree_print_sm_fmt(FILE *out,
 						if (tree->parent_status[i]
 						    == LDNS_STATUS_SSL_ERR) {
 							printf("; SSL Error: ");
+#if OPENSSL_VERSION_NUMBER < 0x10100000L || defined(HAVE_LIBRESSL)
 							ERR_load_crypto_strings();
+#endif
 							ERR_print_errors_fp(stdout);
 							printf("\n");
 						}
diff --git a/drill/drill.c b/drill/drill.c
index 6efd29a5..186bdff2 100644
--- a/drill/drill.c
+++ b/drill/drill.c
@@ -994,10 +994,12 @@ main(int argc, char *argv[])
 	xfree(tsig_algorithm);
 
 #ifdef HAVE_SSL
+#if OPENSSL_VERSION_NUMBER < 0x10100000L || defined(HAVE_LIBRESSL)
 	CRYPTO_cleanup_all_ex_data();
 	ERR_free_strings();
 	EVP_cleanup();
 #endif
+#endif
 #ifdef USE_WINSOCK
 	WSACleanup();
 #endif
diff --git a/keys.c b/keys.c
index 016f9731..06afb739 100644
--- a/keys.c
+++ b/keys.c
@@ -15,6 +15,7 @@
 #include <ldns/ldns.h>
 
 #ifdef HAVE_SSL
+#include <openssl/ui.h>
 #include <openssl/ssl.h>
 #include <openssl/rand.h>
 #include <openssl/bn.h>
